      parameter(mnx=32, mny=mnx, mnz=mnx)
c
      implicit real*8 (a-h,o-z)
      real*8 x(0:mnx,0:mny,0:mnz,3)
      real*8 a(7,0:mnx,0:mny,0:mnz)
      common / ndata1 / nx,ny,nz
      common / rdata1 / x0(3)
      common / rdata2 / epsilon,weight
c
      open(7,file='DATA_FILE',status='old')
      read(7,*) nx,ny,nz
      read(7,*) (x0(i),i=1,3)
      read(7,*) epsilon
      read(7,*) weight
      close(7)

      one = 1.0d0
      hx2 = 2.0d0/dble(nx)
      if(epsilon.lt.hx2) epsilon= hx2
      if(weight.lt.one) weight = one

      itmax = 300
      tol   = 1.0d-4
      print'(" nx = ny = nz  =",i5)',nx
      print'(" itmax for SOR =",i5)',itmax
      print'(" tol   for SOR =",1pe10.2)',tol
c
      one   = 1.0d0
      pi    = dacos(-one)
      rhob  = (dcos(pi/dble(nx))+dcos(pi/dble(ny))+dcos(pi/dble(nz)))
     &       /3.0d0
      if(rhob.ge.one) rhob = 0.98d0
      omega= 2.d0/(one+dsqrt(one-rhob*rhob))
      print'(" SOR parameter =",f8.4/)',omega

      call gridgen(nx,ny,nz,a,x,itmax,tol,omega)
*      call picture(nx,ny,nz,x)
      call pict3(nx,ny,nz,x)
      print*,' Success finale'
c
      stop
      end
